using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestApp
{
	/// <summary>
	/// Summary description for DataGridTest.
	/// </summary>
	public class DataGridTest : System.Windows.Forms.Form
	{
		#region mix

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion


		#region variables

		private System.Windows.Forms.DataGrid m_dataGrid;

		private System.Windows.Forms.Button m_btnLoadMSDN;
		private System.Windows.Forms.Button m_btnLoadMy;
		private System.Windows.Forms.TextBox m_txtSelItem;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button m_btnOK;
		private System.Windows.Forms.Button m_btnCancel;

		private DataTable myTable;
		private DataTable m_BufReportTable;
		private PropertyDescriptor[] m_pd;

		private static string m_strColBufName = "Buffer";
		private static string m_strColBufNameMap = "BufNr";
		private static string m_strColMemVal = "Dedicated memory";
		private static string m_strColMemValMap = "MemVal";

		private System.Windows.Forms.Button m_btnGridContent;
		private static string m_strTabName = "BufRepGrid";

		private static bool m_bIsGridInit = false;

		#endregion


		#region Hauptfunktionen

		#region CTOR

		public DataGridTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			InitDataGridAsTest();

			m_bIsGridInit = true;
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_dataGrid = new System.Windows.Forms.DataGrid();
			this.m_btnLoadMSDN = new System.Windows.Forms.Button();
			this.m_btnLoadMy = new System.Windows.Forms.Button();
			this.m_txtSelItem = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.m_btnOK = new System.Windows.Forms.Button();
			this.m_btnCancel = new System.Windows.Forms.Button();
			this.m_btnGridContent = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.m_dataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// m_dataGrid
			// 
			this.m_dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.m_dataGrid.DataMember = "";
			this.m_dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_dataGrid.Location = new System.Drawing.Point(12, 18);
			this.m_dataGrid.Name = "m_dataGrid";
			this.m_dataGrid.Size = new System.Drawing.Size(372, 186);
			this.m_dataGrid.TabIndex = 3;
			this.m_dataGrid.CurrentCellChanged += new System.EventHandler(this.DataGrid_CurrentCellChanged);
			// 
			// m_btnLoadMSDN
			// 
			this.m_btnLoadMSDN.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_btnLoadMSDN.Location = new System.Drawing.Point(12, 222);
			this.m_btnLoadMSDN.Name = "m_btnLoadMSDN";
			this.m_btnLoadMSDN.Size = new System.Drawing.Size(96, 24);
			this.m_btnLoadMSDN.TabIndex = 4;
			this.m_btnLoadMSDN.Text = "MSDN example";
			this.m_btnLoadMSDN.Click += new System.EventHandler(this.m_btnLoadMSDN_Click);
			// 
			// m_btnLoadMy
			// 
			this.m_btnLoadMy.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_btnLoadMy.Location = new System.Drawing.Point(12, 246);
			this.m_btnLoadMy.Name = "m_btnLoadMy";
			this.m_btnLoadMy.Size = new System.Drawing.Size(96, 24);
			this.m_btnLoadMy.TabIndex = 5;
			this.m_btnLoadMy.Text = "my example";
			this.m_btnLoadMy.Click += new System.EventHandler(this.m_btnLoadMy_Click);
			// 
			// m_txtSelItem
			// 
			this.m_txtSelItem.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_txtSelItem.AutoSize = false;
			this.m_txtSelItem.Location = new System.Drawing.Point(120, 222);
			this.m_txtSelItem.Name = "m_txtSelItem";
			this.m_txtSelItem.Size = new System.Drawing.Size(120, 42);
			this.m_txtSelItem.TabIndex = 6;
			this.m_txtSelItem.Text = "";
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label1.Location = new System.Drawing.Point(12, 318);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(372, 2);
			this.label1.TabIndex = 7;
			this.label1.Text = "label1";
			// 
			// m_btnOK
			// 
			this.m_btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.m_btnOK.Location = new System.Drawing.Point(12, 330);
			this.m_btnOK.Name = "m_btnOK";
			this.m_btnOK.Size = new System.Drawing.Size(96, 24);
			this.m_btnOK.TabIndex = 8;
			this.m_btnOK.Text = "OK";
			// 
			// m_btnCancel
			// 
			this.m_btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.m_btnCancel.Location = new System.Drawing.Point(252, 330);
			this.m_btnCancel.Name = "m_btnCancel";
			this.m_btnCancel.Size = new System.Drawing.Size(96, 24);
			this.m_btnCancel.TabIndex = 9;
			this.m_btnCancel.Text = "Cancel";
			// 
			// m_btnGridContent
			// 
			this.m_btnGridContent.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.m_btnGridContent.Location = new System.Drawing.Point(252, 222);
			this.m_btnGridContent.Name = "m_btnGridContent";
			this.m_btnGridContent.Size = new System.Drawing.Size(132, 24);
			this.m_btnGridContent.TabIndex = 10;
			this.m_btnGridContent.Text = "show grid content";
			this.m_btnGridContent.Click += new System.EventHandler(this.m_btnGridContent_Click);
			// 
			// DataGridTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(394, 369);
			this.Controls.Add(this.m_btnGridContent);
			this.Controls.Add(this.m_btnCancel);
			this.Controls.Add(this.m_btnOK);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.m_txtSelItem);
			this.Controls.Add(this.m_btnLoadMy);
			this.Controls.Add(this.m_btnLoadMSDN);
			this.Controls.Add(this.m_dataGrid);
			this.Name = "DataGridTest";
			this.Text = "DataGridTest";
			this.Enter += new System.EventHandler(this.grid_Enter);
			((System.ComponentModel.ISupportInitialize)(this.m_dataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#endregion



		#region Handles for Grid

		/// <summary>
		/// beim Enter
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void grid_Enter(object sender, EventArgs e) 
		{
			m_dataGrid.CurrentCell = new DataGridCell(2,2);
		}

		
		/// <summary>
		/// wenn eine neue Cell selektiert wird (= SetFocus fr eine Cell)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void DataGrid_CurrentCellChanged(object sender, System.EventArgs e)
		{
			Console.Write(" \nCURRENT_cell_changED: ");
			GetCurrentCell(0);
		}

		
		/// <summary>
		/// Reaktion auf jeden KLick
		/// </summary>
		/// <param name="msg"></param>
		/// <param name="keyData"></param>
		/// <returns></returns>
		protected override bool ProcessCmdKey(ref System.Windows.Forms.Message msg,
			System.Windows.Forms.Keys keyData)
		{
			Console.Write(" \nProcess_CMD_KEY: ");
			//ShowCurValue();

			if(msg.WParam.ToInt32() == (int) Keys.Enter)
			{
				SendKeys.Send("{Tab}"); 
				return true;
			}

			return base.ProcessCmdKey(ref msg, keyData);
		}



		#region DataTable - Events ( Handles fr die Bearbeitung von nderungen in Cellen )

		private static void Column_Changing( object sender, DataColumnChangeEventArgs e )
		{
			if (m_bIsGridInit == true)
			{
				Console.WriteLine( "\nCOLUMN_changING:  ColumnValue = {0} *** ColumnName={1} *** nochwas = {2} ", 
					e.Row[m_strColMemVal], e.Column.ColumnName, e.ProposedValue );
			}
		}
		protected static void OnColumnChanged(object sender, DataColumnChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				Console.Write(" \nCOLUMN_changED: ");
				Console.Write(args.Column.ColumnName + " changed to '" + args.ProposedValue + "'\n");
			}
		}
		protected static void OnRowChanging(object sender, DataRowChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				if (args.Action != DataRowAction.Nothing)
					Console.WriteLine("   \nROW_changING: Action = " + args.Action + ", ColumnValue = " + args.Row[m_strColMemVal]);
			}
		}

		protected static void OnRowChanged(object sender, DataRowChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				if (args.Action != DataRowAction.Nothing)
					Console.WriteLine("\nROW_changED: Action = " + args.Action + ", ColumnValue = " + args.Row[m_strColMemVal]);
			}
		}

		#endregion


		#endregion

		#region Help functions for msdn-example
	
		private void InitDataGrid()
		{
			// als Datenhaltung - DataTable
			// ============================

			// erzeugen Tabelle
			myTable = new DataTable("NamesTable");

			// Spalten einfgen:
			// a) Spalte "Name"
			myTable.Columns.Add(new DataColumn("Name"));
			// b) Spalte "ID"
			DataColumn column = new DataColumn ("id", typeof(System.Int32));
			myTable.Columns.Add(column);
			// c) Spalte "calculatedField"
			myTable.Columns.Add(new DataColumn("calculatedField", typeof(bool)));

			// speichern diese Tabelle als Datentrger im DataSet
			DataSet namesDataSet = new DataSet();
			namesDataSet.Tables.Add(myTable);

			// verbinden Daten mit dem Grid
			m_dataGrid.SetDataBinding(namesDataSet, "NamesTable");
        
			AddTableStyle();
			AddData();
		}

		
		private void AddTableStyle()
		{
			// Map a new  TableStyle to the DataTable. Then 
			// add DataGridColumnStyle objects to the collection
			// of column styles with appropriate mappings.
			DataGridTableStyle dgTableStyle = new DataGridTableStyle();
			dgTableStyle.MappingName = "NamesTable";	// wie DataTable-Name

			// Spalte "Name"
			DataGridTextBoxColumn dgTxtCol = new DataGridTextBoxColumn();
			dgTxtCol.MappingName = "Name";
			dgTxtCol.HeaderText= "Name";
			dgTableStyle.GridColumnStyles.Add(dgTxtCol);

			// Spalte "ID"
			dgTxtCol = new DataGridTextBoxColumn();
			dgTxtCol.MappingName = "id";
			dgTxtCol.HeaderText= "id";
			dgTableStyle.GridColumnStyles.Add(dgTxtCol);

			// Spalte "calculatedField"
			DataGridBoolColumnInherit dbBoolCol = new DataGridBoolColumnInherit();
			dbBoolCol.HeaderText= "less than 1000 = blue";
			dbBoolCol.Width= 150;
			dbBoolCol.MappingName = "calculatedField";
			dgTableStyle.GridColumnStyles.Add(dbBoolCol);

			m_dataGrid.TableStyles.Add(dgTableStyle);

			// This expression instructs the grid to change
			// the color of the inherited DataGridBoolColumn
			// according to the value of the id field. If it's
			// less than 1000, the row is blue. Otherwise,
			// the color is yellow.
			dbBoolCol.Expression = "id < 1000";

			// Handles fr die Bearbeitung von nderungen in Cellen
			myTable.ColumnChanging += new DataColumnChangeEventHandler( Column_Changing );
			myTable.ColumnChanged  += new DataColumnChangeEventHandler(OnColumnChanged);
			myTable.RowChanged     += new DataRowChangeEventHandler(OnRowChanged);
			myTable.RowChanging    += new DataRowChangeEventHandler(OnRowChanging);
		}

		
		private void AddData() 
		{
			// Add data with varying numbers for the id field.
			// If the number is over 1000, the cell will paint
			// yellow. Otherwise, it will be blue.
			DataRow dRow = myTable.NewRow();

			dRow["Name"] = "name 1 ";
			dRow["id"] = 999;
			myTable.Rows.Add(dRow);

			dRow = myTable.NewRow();
			dRow["Name"] = "name 2";
			dRow["id"] = 2300;
			myTable.Rows.Add(dRow);

			dRow = myTable.NewRow();
			dRow["Name"] = "name 3";
			dRow["id"] = 120;
			myTable.Rows.Add(dRow);

			dRow = myTable.NewRow();
			dRow["Name"] = "name 4";
			dRow["id"] = 4023;
			myTable.Rows.Add(dRow);

			dRow = myTable.NewRow();
			dRow["Name"] = "name 5";
			dRow["id"] = 2345;
			myTable.Rows.Add(dRow);

			myTable.AcceptChanges();
		}

		
		#endregion


		#region Help functions for test


		private void InitDataGridAsTest()
		{
			m_dataGrid.TableStyles.Clear();  
			SetGridDataSet();
			SetGridColStyles();

			FillDataInGrid();
		}


		/// <summary>
		/// fllen den Grid aus
		/// </summary>
		private void FillDataInGrid()
		{
			DataRow dRow = m_BufReportTable.NewRow();

			dRow[m_strColBufName] = "PROT\\LLN0\\brcbA";
			dRow[m_strColMemVal] = 10;
			m_BufReportTable.Rows.Add(dRow);

			dRow = m_BufReportTable.NewRow();
			dRow[m_strColBufName] = "PROT\\LLN0\\brcbB";
			dRow[m_strColMemVal] = 10;
			m_BufReportTable.Rows.Add(dRow);

			dRow = m_BufReportTable.NewRow();
			dRow[m_strColBufName] = "MEAS\\LLN0\\brcbC";
			dRow[m_strColMemVal] = 10;
			m_BufReportTable.Rows.Add(dRow);

			m_BufReportTable.AcceptChanges();
		}

		
		/// <summary>
		/// setzen DataSet
		/// </summary>
		private void SetGridDataSet()
		{
			m_pd = new PropertyDescriptor[2];

			m_BufReportTable = new DataTable(m_strTabName);
 
			// Add a new DataColumn to the DataTable. - "BufNr"
			DataColumn myColumn = new DataColumn(m_strColBufName);
			myColumn.DataType = System.Type.GetType("System.String");
			myColumn.DefaultValue = "default string - test";
			m_BufReportTable.Columns.Add(myColumn);

			// Get the CurrencyManager for the DataTable.
			CurrencyManager cm = (CurrencyManager)this.BindingContext[m_BufReportTable];
			// Use the CurrencyManager to get the PropertyDescriptor for the new column.
			m_pd[0] = cm.GetItemProperties()[m_strColBufName];

			// Spalte "MemVal"
			DataColumn myColumn1 = new DataColumn(m_strColMemVal);
			myColumn1.DataType = System.Type.GetType("System.String");
			myColumn1.DefaultValue = "default string - test";
			m_BufReportTable.Columns.Add(myColumn1);
			// Use the CurrencyManager to get the PropertyDescriptor for the new column.
			m_pd[1] = cm.GetItemProperties()[m_strColMemVal];

			m_dataGrid.DataSource= m_BufReportTable;
		}

		
		/// <summary>
		/// setzen alle Spalten mit Styles
		/// </summary>
		private void SetGridColStyles()
		{
			/*
				When programmatically specifying column styles, always create 
				DataGridColumnStyle objects and add them to the 
				GridColumnStylesCollection object before adding 
				DataGridTableStyle objects to the GridTableStylesCollection object. 
				
				When you add an empty DataGridTableStyle object to the collection, 
				DataGridColumnStyle objects are automatically generated for you. 
				Consequently, an exception will be thrown if you try to add new 
				DataGridColumnStyle objects with duplicate MappingName values to 
				the GridColumnStylesCollection object.

			 */ 

			// Create the DataGridTextBoxColumn with the PropertyDescriptor.
			DataGridTextBoxColumn myColumnTextColumn = new DataGridTextBoxColumn(m_pd[0]);

			// Add the new DataGridColumn to the GridColumnsCollection.
			m_dataGrid.TableStyles.Add(new DataGridTableStyle());
			m_dataGrid.TableStyles[0].GridColumnStyles.Add(myColumnTextColumn);

			// Spalte "MemVal"
			myColumnTextColumn = new DataGridTextBoxColumn(m_pd[1]);
			m_dataGrid.TableStyles[0].GridColumnStyles.Add(myColumnTextColumn);

			// add a Column - Row / Changing - Changed event handler for the table.
			m_BufReportTable.ColumnChanging += new DataColumnChangeEventHandler( Column_Changing );
			m_BufReportTable.ColumnChanged  += new DataColumnChangeEventHandler(OnColumnChanged);
			m_BufReportTable.RowChanged     += new DataRowChangeEventHandler(OnRowChanged);
			m_BufReportTable.RowChanging    += new DataRowChangeEventHandler(OnRowChanging);
		}


		#endregion


		#region Allgemeine Hilfsfunktionen

		/// <summary>
		/// geben den Grid-Inhalt im Output - Fenster aus
		/// </summary>
		private void GetAllInfosFromGrid()
		{
			int iCol;
			DataTable myTableTest;
			// Assumes the DataGrid is bound to a DataTable.
			myTableTest = (DataTable) m_dataGrid.DataSource;
			for(int iRow = 0; iRow < myTableTest.Rows.Count ; iRow++) 
			{
				for(iCol = 0; iCol < myTableTest.Columns.Count ; iCol++) 
				{
					Console.WriteLine(m_dataGrid[iRow, iCol]);
				}
			}
		}


		/// <summary>
		/// zeigen den Wert aus der aktuellen Cell
		/// </summary>
		private void ShowCurValue()
		{
			int nCellCol = m_dataGrid.CurrentCell.ColumnNumber;  
			int nCellRow = m_dataGrid.CurrentCell.RowNumber;  

			/* oder so:
				 * 
				DataGridCell olddgc = new DataGridCell(-1, -1);
				olddgc=this.m_dataGrid.CurrentCell;
				string strVal = olddgc.ToString(); 
				*/

			CurrencyManager cm = (CurrencyManager)this.BindingContext[m_BufReportTable];
			cm.Refresh();  
			DataRow dRow = m_BufReportTable.Rows[nCellRow]; 
			string strBufName = dRow[m_strColBufName].ToString(); 
			string strVal = dRow[m_strColMemVal].ToString();

			m_txtSelItem.Text = "name = " + strBufName + " *** value = " + strVal;
			m_txtSelItem.Refresh(); 
		}


		/// <summary>
		/// holen uns ein Objekt fr das aktuelle Cell mit dem Index = nInd
		/// </summary>
		private void GetCurrentCell(int nInd)
		{
			DataGridCell MyCell = new DataGridCell();
			MyCell.RowNumber = m_BufReportTable.Rows.Count - 1; // oder MyCell.RowNumber = nInd 
			m_txtSelItem.Text = MyCell.ToString(); 
			m_txtSelItem.Refresh(); 

			//this.m_dataGrid[MyCell] = m_BufReportTable.Columns. (m_strColMemValMap).ToString();
		}
		
		
		#endregion

		#region Handles for all elements excluding grid

		/// <summary>
		/// MSDN-example
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_btnLoadMSDN_Click(object sender, System.EventArgs e)
		{
			InitDataGrid();
		}

		
		/// <summary>
		/// my test
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_btnLoadMy_Click(object sender, System.EventArgs e)
		{
			InitDataGridAsTest();
		}

		
		/// <summary>
		/// show grid content in output-window
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_btnGridContent_Click(object sender, System.EventArgs e)
		{
			GetAllInfosFromGrid();
		}

		
		#endregion

	}
}


#region DataGridBoolColumnInherit

public class DataGridBoolColumnInherit : DataGridBoolColumn 
{
	private SolidBrush trueBrush = Brushes.Blue as SolidBrush;
	private SolidBrush falseBrush = Brushes.Yellow as SolidBrush;
	private DataColumn expressionColumn = null;
	private static int count = 0;

	public Color FalseColor 
	{
		get 
		{
			return falseBrush.Color;
		}
		set 
		{
			falseBrush = new SolidBrush(value);
			Invalidate();
		}
	}

	public Color TrueColor 
	{
		get 
		{
			return trueBrush.Color;
		}
		set 
		{
			trueBrush = new SolidBrush(value);
			Invalidate();
		}
	}

	public DataGridBoolColumnInherit() : base () 
	{
		count ++;
	}


	// This will work only with a DataSet or DataTable.
	// The code is not compatible with IBindingList implementations.
	public string Expression 
	{
		get 
		{
			return this.expressionColumn == null ? String.Empty : 
				this.expressionColumn.Expression;
		}
		set 
		{
			if (expressionColumn == null)
				AddExpressionColumn(value);
			else 
				expressionColumn.Expression = value;
			if (expressionColumn != null && 
				expressionColumn.Expression.Equals(value))
				return;
			Invalidate();
		}
	}

	private void AddExpressionColumn(string value) 
	{
		// Get the grid's data source. First check for a null 
		// table or data grid.
		if (this.DataGridTableStyle == null || 
			this.DataGridTableStyle.DataGrid == null)
			return;

		DataGrid myGrid = this.DataGridTableStyle.DataGrid;
		DataView myDataView = ((CurrencyManager) 
			myGrid.BindingContext[myGrid.DataSource, 
			myGrid.DataMember]).List 
			as DataView;

		// This works only with System.Data.DataTable.
		if (myDataView == null)
			return;

		// If the user already added a column with the name 
		// then exit. Otherwise, add the column and set the 
		// expression to the value passed to this function.
		DataColumn col = myDataView.Table.Columns["__Computed__Column__"];
		if (col != null)
			return;
		col = new DataColumn("__Computed__Column__" + count.ToString());

		myDataView.Table.Columns.Add(col);
		col.Expression = value;
		expressionColumn = col;
	}

	// override the OnPaint method to paint the cell based on the expression.
	protected override void Paint(Graphics g, Rectangle bounds,
		CurrencyManager source, int rowNum,
		Brush backBrush, Brush foreBrush,
		bool alignToRight) 
	{
		bool trueExpression = false;
		bool hasExpression = false;
		DataRowView drv = source.List[rowNum] as DataRowView;

		hasExpression = this.expressionColumn != null && 
			this.expressionColumn.Expression != null && 
			!this.expressionColumn.Expression.Equals(String.Empty);

		Console.WriteLine(string.Format("hasExpressionValue {0}",hasExpression));
		// Get the value from the expression column.
		// For simplicity, we assume a True/False value for the 
		// expression column.
		if (hasExpression) 
		{
			object expr = drv.Row[expressionColumn.ColumnName];
			trueExpression = expr.Equals("True");
		}

		// Let the DataGridBoolColumn do the painting.
		if (!hasExpression)
			base.Paint(g, bounds, source, rowNum, 
				backBrush, foreBrush, alignToRight);

		// Paint using the expression color for true or false, as calculated.
		if (trueExpression)
			base.Paint(g, bounds, source, rowNum, 
				trueBrush, foreBrush, alignToRight);
		else
			base.Paint(g, bounds, source, rowNum, 
				falseBrush, foreBrush, alignToRight);
	}
}

#endregion

