using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestApp
{
	/// <summary>
	/// Summary description for TxtBoxArray.
	/// </summary>
	public class TxtBoxArray : System.Windows.Forms.Form
	{

		#region Controls variables
		/// <summary>
		/// Controls variables
		/// </summary>
		/// 
		private System.Windows.Forms.TextBox m_Edit_1;
		private System.Windows.Forms.TextBox m_Edit_2;
		private System.Windows.Forms.TextBox m_Edit_3;

		private System.Windows.Forms.TextBox[] m_Edit;

		#endregion

		#region Required designer variables

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#endregion

		#region Help functions
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		public TxtBoxArray()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			m_Edit = new System.Windows.Forms.TextBox[3];
			m_Edit[0] = m_Edit_1; 
			m_Edit[1] = m_Edit_2;
			m_Edit[2] = m_Edit_3;

			for (int i = 0; i < 3; i++)
			{
				m_Edit[i].TextChanged += new System.EventHandler(this.m_Edit_TextChanged);
			}
		}

		private int GetSenderIndex(object sender)
		{
			int nBtnIndex = 0;

			for (int i = 0; i < 3; i++)
			{
				if (sender == m_Edit[i])
				{
					nBtnIndex = i;
					break;
				}
			}
			return nBtnIndex;
		}


		private void m_Edit_TextChanged(object sender, System.EventArgs e)
		{
			int nBtnIndex = GetSenderIndex(sender);

			string strVal = m_Edit[nBtnIndex].Text;
		}



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_Edit_1 = new System.Windows.Forms.TextBox();
			this.m_Edit_2 = new System.Windows.Forms.TextBox();
			this.m_Edit_3 = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// m_Edit_1
			// 
			this.m_Edit_1.Location = new System.Drawing.Point(18, 18);
			this.m_Edit_1.Name = "m_Edit_1";
			this.m_Edit_1.Size = new System.Drawing.Size(66, 20);
			this.m_Edit_1.TabIndex = 0;
			this.m_Edit_1.Text = "textBox1";
			// 
			// m_Edit_2
			// 
			this.m_Edit_2.Location = new System.Drawing.Point(96, 18);
			this.m_Edit_2.Name = "m_Edit_2";
			this.m_Edit_2.Size = new System.Drawing.Size(66, 20);
			this.m_Edit_2.TabIndex = 1;
			this.m_Edit_2.Text = "textBox2";
			// 
			// m_Edit_3
			// 
			this.m_Edit_3.Location = new System.Drawing.Point(174, 18);
			this.m_Edit_3.Name = "m_Edit_3";
			this.m_Edit_3.Size = new System.Drawing.Size(66, 20);
			this.m_Edit_3.TabIndex = 2;
			this.m_Edit_3.Text = "textBox3";
			// 
			// TxtBoxArray
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(256, 75);
			this.Controls.Add(this.m_Edit_3);
			this.Controls.Add(this.m_Edit_2);
			this.Controls.Add(this.m_Edit_1);
			this.Name = "TxtBoxArray";
			this.Text = "TxtBoxArray";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
