using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestApp.BufReport_DataGrid
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class frmBufReportSettings : System.Windows.Forms.Form
	{
		#region Controls variables
		/// <summary>
		/// Controls variables
		/// </summary>
		
		private System.Windows.Forms.Label m_lblBuf1;
		private System.Windows.Forms.TextBox m_txtBufMem1;
		private System.Windows.Forms.TextBox m_txtBufMem2;
		private System.Windows.Forms.Label m_lblBuf2;
		private System.Windows.Forms.TextBox m_txtBufMem3;
		private System.Windows.Forms.Label m_lblBuf3;
		private System.Windows.Forms.TextBox m_txtBufMem4;
		private System.Windows.Forms.Label m_lblBuf4;
		private System.Windows.Forms.TextBox m_txtBufMem5;
		private System.Windows.Forms.Label m_lblBuf5;
		private System.Windows.Forms.TextBox m_txtBufMem6;
		private System.Windows.Forms.Label m_lblBuf6;
		private System.Windows.Forms.TextBox m_txtBufMem7;
		private System.Windows.Forms.Label m_lblBuf7;
		private System.Windows.Forms.TextBox m_txtBufMem8;
		private System.Windows.Forms.Label m_lblBuf8;
		private System.Windows.Forms.TextBox m_txtBufMem9;
		private System.Windows.Forms.Label m_lblBuf9;
		private System.Windows.Forms.TextBox m_txtBufMem10;
		private System.Windows.Forms.Label m_lblBuf10;
		private System.Windows.Forms.TextBox m_txtMemSize;
		private System.Windows.Forms.Label m_lbl_Memory_Rest;
		private System.Windows.Forms.Label m_lbl_Separator;

		private System.Windows.Forms.TextBox[] m_txtBufMem;

		private System.Windows.Forms.Button m_btnOK;
		private System.Windows.Forms.Button m_btnCancel;
		private System.Windows.Forms.Button m_btnHlp;


		#endregion

		#region Required designer variables

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Memory Rest
		/// </summary>
		private int m_nMemoryRest = 100;


		#endregion

		#region other variables

		private BufReportSettingsData m_BufSizeData;

		private string m_strBuffSizeAsOneStr = "";

		#endregion


		#region Hauptfunktionen

		#region CTOR

		public frmBufReportSettings(int nCountOfBuffers, int[] InitBufSizes)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			// erzeugen unser Container - Objekt
			m_BufSizeData = new BufReportSettingsData(nCountOfBuffers, InitBufSizes);

			m_txtBufMem = new System.Windows.Forms.TextBox[nCountOfBuffers];
			for (int i = 0; i < nCountOfBuffers; i++)
			{
				switch (i)
				{
					case 0:
						m_txtBufMem[i] = m_txtBufMem1;
						break;

					case 1:
						m_txtBufMem[i] = m_txtBufMem2;
						break;

					case 2:
						m_txtBufMem[i] = m_txtBufMem3;
						break;

					case 3:
						m_txtBufMem[i] = m_txtBufMem4;
						break;

					case 4:
						m_txtBufMem[i] = m_txtBufMem5;
						break;

					case 5:
						m_txtBufMem[i] = m_txtBufMem6;
						break;

					case 6:
						m_txtBufMem[i] = m_txtBufMem7;
						break;

					case 7:
						m_txtBufMem[i] = m_txtBufMem8;
						break;

					case 8:
						m_txtBufMem[i] = m_txtBufMem9;
						break;

					case 9:
						m_txtBufMem[i] = m_txtBufMem10;
						break;
				}
			}

			// setzen den Start-Wert
			for (int i = 0; i < nCountOfBuffers; i++)
			{
				m_txtBufMem[i].Text = Convert.ToString(InitBufSizes[i]);
			}

			for (int i = 0; i < nCountOfBuffers; i++)
			{
				m_txtBufMem[i].LostFocus += new EventHandler(this.TxtBufMem_LostFocus);
				m_txtBufMem[i].TextChanged += new System.EventHandler(this.m_txtBufMem_TextChanged);

			}
		}

		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_lblBuf1 = new System.Windows.Forms.Label();
			this.m_txtBufMem1 = new System.Windows.Forms.TextBox();
			this.m_txtBufMem2 = new System.Windows.Forms.TextBox();
			this.m_lblBuf2 = new System.Windows.Forms.Label();
			this.m_txtBufMem3 = new System.Windows.Forms.TextBox();
			this.m_lblBuf3 = new System.Windows.Forms.Label();
			this.m_txtBufMem4 = new System.Windows.Forms.TextBox();
			this.m_lblBuf4 = new System.Windows.Forms.Label();
			this.m_txtBufMem5 = new System.Windows.Forms.TextBox();
			this.m_lblBuf5 = new System.Windows.Forms.Label();
			this.m_txtBufMem6 = new System.Windows.Forms.TextBox();
			this.m_lblBuf6 = new System.Windows.Forms.Label();
			this.m_txtBufMem7 = new System.Windows.Forms.TextBox();
			this.m_lblBuf7 = new System.Windows.Forms.Label();
			this.m_txtBufMem8 = new System.Windows.Forms.TextBox();
			this.m_lblBuf8 = new System.Windows.Forms.Label();
			this.m_txtBufMem9 = new System.Windows.Forms.TextBox();
			this.m_lblBuf9 = new System.Windows.Forms.Label();
			this.m_txtBufMem10 = new System.Windows.Forms.TextBox();
			this.m_lblBuf10 = new System.Windows.Forms.Label();
			this.m_txtMemSize = new System.Windows.Forms.TextBox();
			this.m_lbl_Memory_Rest = new System.Windows.Forms.Label();
			this.m_lbl_Separator = new System.Windows.Forms.Label();
			this.m_btnOK = new System.Windows.Forms.Button();
			this.m_btnCancel = new System.Windows.Forms.Button();
			this.m_btnHlp = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// m_lblBuf1
			// 
			this.m_lblBuf1.Location = new System.Drawing.Point(8, 16);
			this.m_lblBuf1.Name = "m_lblBuf1";
			this.m_lblBuf1.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf1.TabIndex = 0;
			this.m_lblBuf1.Text = "Dedicated memory for buffer 1 (in %):";
			// 
			// m_txtBufMem1
			// 
			this.m_txtBufMem1.AutoSize = false;
			this.m_txtBufMem1.Location = new System.Drawing.Point(216, 16);
			this.m_txtBufMem1.Name = "m_txtBufMem1";
			this.m_txtBufMem1.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem1.TabIndex = 1;
			this.m_txtBufMem1.Text = "10";
			// 
			// m_txtBufMem2
			// 
			this.m_txtBufMem2.AutoSize = false;
			this.m_txtBufMem2.Location = new System.Drawing.Point(216, 48);
			this.m_txtBufMem2.Name = "m_txtBufMem2";
			this.m_txtBufMem2.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem2.TabIndex = 3;
			this.m_txtBufMem2.Text = "10";
			// 
			// m_lblBuf2
			// 
			this.m_lblBuf2.Location = new System.Drawing.Point(8, 48);
			this.m_lblBuf2.Name = "m_lblBuf2";
			this.m_lblBuf2.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf2.TabIndex = 2;
			this.m_lblBuf2.Text = "Dedicated memory for buffer 2 (in %):";
			// 
			// m_txtBufMem3
			// 
			this.m_txtBufMem3.AutoSize = false;
			this.m_txtBufMem3.Location = new System.Drawing.Point(216, 80);
			this.m_txtBufMem3.Name = "m_txtBufMem3";
			this.m_txtBufMem3.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem3.TabIndex = 5;
			this.m_txtBufMem3.Text = "10";
			// 
			// m_lblBuf3
			// 
			this.m_lblBuf3.Location = new System.Drawing.Point(8, 80);
			this.m_lblBuf3.Name = "m_lblBuf3";
			this.m_lblBuf3.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf3.TabIndex = 4;
			this.m_lblBuf3.Text = "Dedicated memory for buffer 3 (in %):";
			// 
			// m_txtBufMem4
			// 
			this.m_txtBufMem4.AutoSize = false;
			this.m_txtBufMem4.Location = new System.Drawing.Point(216, 112);
			this.m_txtBufMem4.Name = "m_txtBufMem4";
			this.m_txtBufMem4.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem4.TabIndex = 7;
			this.m_txtBufMem4.Text = "10";
			// 
			// m_lblBuf4
			// 
			this.m_lblBuf4.Location = new System.Drawing.Point(8, 112);
			this.m_lblBuf4.Name = "m_lblBuf4";
			this.m_lblBuf4.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf4.TabIndex = 6;
			this.m_lblBuf4.Text = "Dedicated memory for buffer 4 (in %):";
			// 
			// m_txtBufMem5
			// 
			this.m_txtBufMem5.AutoSize = false;
			this.m_txtBufMem5.Location = new System.Drawing.Point(216, 144);
			this.m_txtBufMem5.Name = "m_txtBufMem5";
			this.m_txtBufMem5.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem5.TabIndex = 9;
			this.m_txtBufMem5.Text = "10";
			// 
			// m_lblBuf5
			// 
			this.m_lblBuf5.Location = new System.Drawing.Point(8, 144);
			this.m_lblBuf5.Name = "m_lblBuf5";
			this.m_lblBuf5.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf5.TabIndex = 8;
			this.m_lblBuf5.Text = "Dedicated memory for buffer 5 (in %):";
			// 
			// m_txtBufMem6
			// 
			this.m_txtBufMem6.AutoSize = false;
			this.m_txtBufMem6.Location = new System.Drawing.Point(216, 176);
			this.m_txtBufMem6.Name = "m_txtBufMem6";
			this.m_txtBufMem6.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem6.TabIndex = 11;
			this.m_txtBufMem6.Text = "10";
			// 
			// m_lblBuf6
			// 
			this.m_lblBuf6.Location = new System.Drawing.Point(8, 176);
			this.m_lblBuf6.Name = "m_lblBuf6";
			this.m_lblBuf6.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf6.TabIndex = 10;
			this.m_lblBuf6.Text = "Dedicated memory for buffer 6 (in %):";
			// 
			// m_txtBufMem7
			// 
			this.m_txtBufMem7.AutoSize = false;
			this.m_txtBufMem7.Location = new System.Drawing.Point(216, 208);
			this.m_txtBufMem7.Name = "m_txtBufMem7";
			this.m_txtBufMem7.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem7.TabIndex = 13;
			this.m_txtBufMem7.Text = "10";
			// 
			// m_lblBuf7
			// 
			this.m_lblBuf7.Location = new System.Drawing.Point(8, 208);
			this.m_lblBuf7.Name = "m_lblBuf7";
			this.m_lblBuf7.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf7.TabIndex = 12;
			this.m_lblBuf7.Text = "Dedicated memory for buffer 7 (in %):";
			// 
			// m_txtBufMem8
			// 
			this.m_txtBufMem8.AutoSize = false;
			this.m_txtBufMem8.Location = new System.Drawing.Point(216, 240);
			this.m_txtBufMem8.Name = "m_txtBufMem8";
			this.m_txtBufMem8.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem8.TabIndex = 15;
			this.m_txtBufMem8.Text = "10";
			// 
			// m_lblBuf8
			// 
			this.m_lblBuf8.Location = new System.Drawing.Point(8, 240);
			this.m_lblBuf8.Name = "m_lblBuf8";
			this.m_lblBuf8.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf8.TabIndex = 14;
			this.m_lblBuf8.Text = "Dedicated memory for buffer 8 (in %):";
			// 
			// m_txtBufMem9
			// 
			this.m_txtBufMem9.AutoSize = false;
			this.m_txtBufMem9.Location = new System.Drawing.Point(216, 272);
			this.m_txtBufMem9.Name = "m_txtBufMem9";
			this.m_txtBufMem9.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem9.TabIndex = 17;
			this.m_txtBufMem9.Text = "10";
			// 
			// m_lblBuf9
			// 
			this.m_lblBuf9.Location = new System.Drawing.Point(8, 272);
			this.m_lblBuf9.Name = "m_lblBuf9";
			this.m_lblBuf9.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf9.TabIndex = 16;
			this.m_lblBuf9.Text = "Dedicated memory for buffer 9 (in %):";
			// 
			// m_txtBufMem10
			// 
			this.m_txtBufMem10.AutoSize = false;
			this.m_txtBufMem10.Location = new System.Drawing.Point(216, 304);
			this.m_txtBufMem10.Name = "m_txtBufMem10";
			this.m_txtBufMem10.Size = new System.Drawing.Size(90, 24);
			this.m_txtBufMem10.TabIndex = 19;
			this.m_txtBufMem10.Text = "10";
			// 
			// m_lblBuf10
			// 
			this.m_lblBuf10.Location = new System.Drawing.Point(8, 304);
			this.m_lblBuf10.Name = "m_lblBuf10";
			this.m_lblBuf10.Size = new System.Drawing.Size(200, 24);
			this.m_lblBuf10.TabIndex = 18;
			this.m_lblBuf10.Text = "Dedicated memory for buffer 10(in %):";
			// 
			// m_txtMemSize
			// 
			this.m_txtMemSize.AutoSize = false;
			this.m_txtMemSize.Location = new System.Drawing.Point(216, 360);
			this.m_txtMemSize.Name = "m_txtMemSize";
			this.m_txtMemSize.Size = new System.Drawing.Size(90, 24);
			this.m_txtMemSize.TabIndex = 21;
			this.m_txtMemSize.Text = "0";
			// 
			// m_lbl_Memory_Rest
			// 
			this.m_lbl_Memory_Rest.Location = new System.Drawing.Point(8, 360);
			this.m_lbl_Memory_Rest.Name = "m_lbl_Memory_Rest";
			this.m_lbl_Memory_Rest.Size = new System.Drawing.Size(200, 24);
			this.m_lbl_Memory_Rest.TabIndex = 20;
			this.m_lbl_Memory_Rest.Text = "Rest of memory volume   (in %):";
			// 
			// m_lbl_Separator
			// 
			this.m_lbl_Separator.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.m_lbl_Separator.Location = new System.Drawing.Point(8, 344);
			this.m_lbl_Separator.Name = "m_lbl_Separator";
			this.m_lbl_Separator.Size = new System.Drawing.Size(296, 2);
			this.m_lbl_Separator.TabIndex = 22;
			// 
			// m_btnOK
			// 
			this.m_btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.m_btnOK.Location = new System.Drawing.Point(8, 400);
			this.m_btnOK.Name = "m_btnOK";
			this.m_btnOK.Size = new System.Drawing.Size(88, 24);
			this.m_btnOK.TabIndex = 23;
			this.m_btnOK.Text = "OK";
			this.m_btnOK.Click += new System.EventHandler(this.m_btnOK_Click);
			// 
			// m_btnCancel
			// 
			this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.m_btnCancel.Location = new System.Drawing.Point(144, 400);
			this.m_btnCancel.Name = "m_btnCancel";
			this.m_btnCancel.Size = new System.Drawing.Size(88, 24);
			this.m_btnCancel.TabIndex = 24;
			this.m_btnCancel.Text = "Cancel";
			// 
			// m_btnHlp
			// 
			this.m_btnHlp.Location = new System.Drawing.Point(248, 400);
			this.m_btnHlp.Name = "m_btnHlp";
			this.m_btnHlp.TabIndex = 0;
			this.m_btnHlp.Text = "Help";
			// 
			// frmBufReportSettings
			// 
			this.AcceptButton = this.m_btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 429);
			this.Controls.Add(this.m_btnHlp);
			this.Controls.Add(this.m_btnCancel);
			this.Controls.Add(this.m_btnOK);
			this.Controls.Add(this.m_lbl_Separator);
			this.Controls.Add(this.m_txtMemSize);
			this.Controls.Add(this.m_txtBufMem10);
			this.Controls.Add(this.m_txtBufMem9);
			this.Controls.Add(this.m_txtBufMem8);
			this.Controls.Add(this.m_txtBufMem7);
			this.Controls.Add(this.m_txtBufMem6);
			this.Controls.Add(this.m_txtBufMem5);
			this.Controls.Add(this.m_txtBufMem4);
			this.Controls.Add(this.m_txtBufMem3);
			this.Controls.Add(this.m_txtBufMem2);
			this.Controls.Add(this.m_txtBufMem1);
			this.Controls.Add(this.m_lbl_Memory_Rest);
			this.Controls.Add(this.m_lblBuf10);
			this.Controls.Add(this.m_lblBuf9);
			this.Controls.Add(this.m_lblBuf8);
			this.Controls.Add(this.m_lblBuf7);
			this.Controls.Add(this.m_lblBuf6);
			this.Controls.Add(this.m_lblBuf5);
			this.Controls.Add(this.m_lblBuf4);
			this.Controls.Add(this.m_lblBuf3);
			this.Controls.Add(this.m_lblBuf2);
			this.Controls.Add(this.m_lblBuf1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmBufReportSettings";
			this.Text = "Settings for buffered report";
			this.Load += new System.EventHandler(this.frmBufReportSettings_Load);
			this.ResumeLayout(false);

		}
		#endregion


		#endregion


		#region other functions

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#endregion



		#region Help Methods

		/// <summary>
		/// liefert den Index vom richtigen (aktuellen) TextBox
		/// </summary>
		/// <param name="sender"></param>
		/// <returns></returns>
		private int GetSenderIndex(object sender)
		{
			int nBtnIndex = 0;

			for (int i = 0; i < m_BufSizeData.BuffCount; i++)
			{
				if (sender == m_txtBufMem[i])
				{
					nBtnIndex = i;
					break;
				}
			}

			return nBtnIndex;
		}


		#endregion


		#region Message Handles
		
		/// <summary>
		/// laden die Form
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void frmBufReportSettings_Load(object sender, System.EventArgs e)
		{
		}

				
		/// <summary>
		/// Reaktion auf irgendeine nderung im TextBox
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_txtBufMem_TextChanged(object sender, System.EventArgs e)
		{
			// holen den aktuellen Index
			int nBtnIndex = GetSenderIndex(sender);

			// holen den aktuellen Wert
			string strVal = m_txtBufMem[nBtnIndex].Text;

			// prfen, ob es eine Ziffer ist
			bool bIsNumber = m_BufSizeData.IsCharValid(ref strVal);
			if (false == bIsNumber)
			{
				//MessageBox.Show("Ungltige Eingabe - man darf nur Ziffern eintragen"); 

				m_txtBufMem[nBtnIndex].Text = strVal;
				m_txtBufMem[nBtnIndex].Refresh(); 
			}
		}

		
		
		/// <summary>
		/// Reaktion auf LostFocus fr den TextBox
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void TxtBufMem_LostFocus(object sender, System.EventArgs e)
		{
			int nVal = 0;

			// holen den aktuellen Index
			int nBtnIndex = GetSenderIndex(sender);

			// holen den aktuellen Wert
			string strVal = m_txtBufMem[nBtnIndex].Text;

			// prfen, ob der Wert < 100 ist
			bool bIsValid = m_BufSizeData.CheckInsertedValue(strVal, ref nVal);
			if (bIsValid == false) 
			{
				MessageBox.Show(m_BufSizeData.m_strErrMsg_BufReport, "Fehler"); 

				m_txtBufMem[nBtnIndex].Focus();  
				return;
			}

			// berechnen den alten Zustand vom MemoryRest
			m_BufSizeData.SaveCurValueForBuf(nBtnIndex, strVal);
			m_nMemoryRest = m_BufSizeData.CalcRestOfMemory();
			if (m_nMemoryRest < 0)
			{
//				m_txtMemSize.BackColor = Color.Red; 
			}
			else
			{
//				m_txtMemSize.BackColor = Color.Black; 
			}
			string strMemRest = Convert.ToString(m_nMemoryRest);
			m_txtMemSize.Text = strMemRest;
			m_txtMemSize.Refresh(); 
		}

		

		/// <summary>
		/// Reaktion auf OK - ButtonClick
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_btnOK_Click(object sender, System.EventArgs e)
		{
			bool bIsOk = m_BufSizeData.CheckResults();
			if (bIsOk == true)
			{
				base.DialogResult = DialogResult.OK;
			}
			else
			{
				base.DialogResult = DialogResult.None;
				MessageBox.Show("Passen Sie bitte alle Werte so, dass die Summe > 0 wird", "Fehler");
			}
		}
		
		
		#endregion


		#region Get / Set

		public string StrBuffSizeAsOneStr
		{
			get 
			{ 
				return m_strBuffSizeAsOneStr = m_BufSizeData.BuffSizesAsOneStr; 
			}
		}

		#endregion
	}
}
