using System;

using System.Drawing;
using System.Drawing.Design;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Data;

namespace TestApp.PropertyGrid_all
{
	/// <summary>
	/// Summary description for DynamicProperty.
	/// </summary>
	public class DynamicProperty : FilterablePropertyBase
	{
		private string m_strName = "Ivanov";
		private string m_strAuto = "Oka";

		public DynamicProperty()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		[CategoryAttribute("Einstellungen"),
		DescriptionAttribute("Familija"),
		DefaultValueAttribute("Petrov")]
		public string Name
		{
			get { return m_strName;}
			set { m_strName = value;}
		}

		[CategoryAttribute("Einstellungen"),
		DescriptionAttribute("Marka mashini"),
		DefaultValueAttribute("Drova"),
		DynamicPropertyFilter("Name", "Ivanov, Sidorov")]
		public string Auto
		{
			get { return m_strAuto;}
			set { m_strAuto = value;}
		}
	}
}
